import { ActivityOptions, Client, Message } from "discord.js";
import { Response } from "../response/response";
import { Console } from "../console/console";
import { DataLoader } from "../data";
import { VoiceControl } from "../voice";
export interface MessageResponse {
    message: string;
    react?: string;
    reply?: boolean;
    audio?: boolean;
}
export interface SBotOptions {
    token?: string;
    activityRefreshInterval?: number;
}
export interface TTSOptions {
    prefix?: string;
    onJoin?: string;
}
export declare class SBotClient {
    client: Client;
    get user(): import("discord.js").ClientUser | null;
    private utility;
    constructor(options?: SBotOptions);
    private state;
    useActivity(activity: ActivityOptions): void;
    private setSelfActivity;
    useResponse(response: Response): void;
    private response;
    useConsole(console: Console): void;
    useDataLoader(loader: DataLoader): void;
    voiceOptions?: VoiceOptions;
    voiceCtrl?: VoiceControl;
    useVoice(options: VoiceOptions): void;
    ttsJutsu(msg: Message, content: string): Promise<void>;
    sodJoin(msg: Message): Promise<void>;
    sodLeave(msg: Message): Promise<void>;
}
interface CorgiSwiftJutsu {
    jutsu: "CorgiSwift";
    fallback?: {};
}
interface SOnDemand {
    jutsu: "SOnDemand";
    prefix: {
        join: string[];
        leave: string[];
    };
    onJoin?: string;
    fallback?: {
        join_fail?: {
            message?: {
                no_channel?: string;
                stage_channel?: string;
                internal?: string;
            };
            reply?: boolean;
        };
        already_join?: {
            message?: string;
            reply?: boolean;
        };
        onsite_leave?: {
            message?: string;
            reply?: boolean;
        };
    };
    rules?: {
        onsite_leave: boolean;
    };
}
export declare type VoiceOptions = CorgiSwiftJutsu | SOnDemand;
export {};
