import readline from "readline";
export class Console {
    constructor(client) {
        this.loaders = [];
        this.sbclient = client;
        const rl = readline.createInterface({
            input: process.stdin,
            output: process.stdout,
        });
        rl.on("line", (cmd) => {
            this.execute(cmd);
        });
    }
    execute(cmd) {
        const cmds = cmd.split(" ");
        switch (cmds[0]) {
            case "reload":
                for (const loader of this.loaders)
                    loader.loadData();
                break;
            case "logout":
                this.sbclient?.client?.destroy();
                process.exit(0);
            default:
                return "Unknown Command";
        }
    }
    addLoader(...args) {
        this.loaders.push(...args);
    }
}
