import fetch from "node-fetch";
import { StringLoader } from "./stringLoader";
import { sLogger } from "../../logger";
export class OnlineLoader extends StringLoader {
    constructor(url, data_key, transform) {
        super(transform);
        this.url = url;
        this.data_key = data_key;
        this.loadData();
    }
    async loadData() {
        try {
            const res = await fetch(this.url);
            if (res.status >= 400)
                throw `Error ${res.status}`;
            const restxt = await res.text();
            const obj = JSON.parse(restxt);
            this.data = this.mapTransform(this.data_key ? obj[this.data_key] : obj);
            sLogger.log(`Successfully fetched ${this.data.length} datas from ${this.url}`, "SUCCESS");
        }
        catch (err) {
            sLogger.log(`Can't fetch data from ${this.url}`, "ERROR");
        }
    }
}
